#include "mainwindow.h"
#include "./ui_mainwindow.h"
#include "sensorlayout.h"
#include "sensorwidget.h"
#include "httpclient.h"

#include <QComboBox>
#include <QGridLayout>
#include <QResizeEvent>
#include <QScrollArea>

#include <QDebug>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    // Создаем QScrollArea для прокрутки
    QScrollArea *scrollArea = new QScrollArea(this);
    scrollArea->setStyleSheet("background: transparent; border: 0;");
    SensorLayout *sl = new SensorLayout(scrollArea);
    scrollArea->setLayout(sl); // Устанавливаем контейнер
    scrollArea->setWidgetResizable(true); // Контейнер будет растягиваться по области просмотра
    scrollArea->setVerticalScrollBarPolicy(Qt::ScrollBarAsNeeded);
    scrollArea->setHorizontalScrollBarPolicy(Qt::ScrollBarAsNeeded);

    // Добавляем QScrollArea в основной layout
    ui->SensorsTabLayout->addWidget(scrollArea);

    // Добавляем виджеты в SensorLayout
    int rows = 3;    // Количество строк
    int columns = 3; // Количество столбцов

    for (int row = 0; row < rows; ++row) {
        for (int col = 0; col < columns; ++col) {
            const QString a = QString::number(row);
            const QString b = QString::number(col);
            const QString c = QString::number(row + col);
            SensorWidget *sensor = new SensorWidget(nullptr, a, b, c);
            sl->addWidget(sensor);
        }
    }

    HttpClient httpClient;
    for (int i = 0; i < 10; ++i) {
        QJsonObject getResult = httpClient.get("http://raspberrypi.lan:8080/data/getDevices");
        qDebug() << "GET Response:" << getResult;
    }
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::ResizeEvent(QResizeEvent *event) {}

void MainWindow::SetupTabs() {}

void MainWindow::SetupSensorTab(QWidget *tab, QVBoxLayout *mainLayout) {}

void MainWindow::SetupIncidentTab(QWidget *tab, QVBoxLayout *mainLayout) {}

void MainWindow::SetupStatisticsTab(QWidget *tab, QVBoxLayout *mainLayout) {}

void MainWindow::SetupJournalTab(QWidget *tab, QVBoxLayout *mainLayout) {}

void MainWindow::SetupSettingsTab(QWidget *tab, QVBoxLayout *mainLayout) {}
